# black
[tool.black]
line-length = 100
skip-string-normalization=true
extend-exclude = '''
/(
  | .local/*
  | .venv/*
)/
'''
# mypy
[tool.mypy]
files = '.'
pretty = true
show_error_codes = true
# vscode/dmypy: follow-imports=silent not supported
# follow_imports = 'silent'
follow_imports = 'normal'
explicit_package_bases = true
namespace_packages = true
platform = 'linux'
check_untyped_defs = true
disallow_any_generics = true
disallow_incomplete_defs = true
disallow_subclassing_any = false
disallow_untyped_calls = true
disallow_untyped_decorators = false
disallow_untyped_defs = true
ignore_missing_imports = true
no_implicit_reexport = true
strict = true
strict_optional = true
warn_redundant_casts = true
warn_unused_configs = true
warn_unused_ignores = false

plugins = []
exclude = [
    '.venv',
    '.local',
]
# isort
[tool.isort]
profile ='black'
skip=[
    '.venv',
    './.local'
]
include_trailing_comma=true
force_grid_wrap=0
use_parentheses=true
line_length=100
[tool.pydocstyle]
match-dir='([^!(.venv)].*)([^!(.local)].*)'
# pylint
[tool.pylint.master]
load-plugins = [
    'pylint.extensions.mccabe',
    'pylint.extensions.redefined_variable_type',
    'pylint.extensions.broad_try_clause',
    'pylint.extensions.no_self_use'
]
generated-members = [
]
extension-pkg-whitelist= [
    "pydantic",
]
fail-under=8.0
ignore=["CVS"]
ignore-paths = [
    "^(.*)/.venv/*",
    "^(.*)/.local/.*",
    ".venv/*",
    ".local/.*",
]

unsafe-load-any-extension="no"

[tool.pylint.messages_control]
enable=["c-extension-no-member"]
[tool.pylint.fotmat]
max-line-length=100
[tool.pylint.similarities]
ignore-imports="yes"
ignore-signatures="yes"
min-similarity-lines=10
[tool.pylint.design]
max-args=15
max-attributes=15
# bandit
[tool.bandit]
exclude_dirs = [
    ".venv",
    ".local",
]

skips = []
[tool.bandit.assert_used]
skips = []

# ruff
[tool.ruff]
line-length = 100
extend-exclude = []

[tool.ruff.lint]
select = ["E4", "E7", "E9", "F", "Q"]
ignore = []
# # Allow fix for all enabled rules (when `--fix`) is provided.
fixable = ["ALL"]
unfixable = []

# # Allow unused variables when underscore-prefixed.
dummy-variable-rgx = "^(_+|(_+[a-zA-Z0-9_]*[a-zA-Z0-9]+?))$"

[tool.ruff.format]
exclude = ["*.pyi", "*.j2"]
# Like Black, use double quotes for strings.
quote-style = "double"
# Like Black, indent with spaces, rather than tabs.
indent-style = "space"
# Like Black, respect magic trailing commas.
skip-magic-trailing-comma = false
line-ending = "lf"
